



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Ruby学习之对象模型</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Ruby学习之对象模型</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 13:41:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>这两周工作内容较多，平时自己也有点不在状态，学的东西有点少了，趁着现在还有点状态，赶紧复习一下之前学习的Ruby吧。</p>
<p>Ruby是我真正开始接触动态语言魅力的第一个语言，之前虽然也用过且一直用perl、python等脚本语言，但是只是作为unix shell的扩展（和工作有关），没有真正地审视动态语言的哲学。是《Ruby元编程》这本书，好像给我打开了一扇新世界的大门，书中介绍的每一个特性都让我兴奋地几乎跳起来，这就是学习的魅力吧。</p>
<h3>Ruby语言初探</h3>
<p>由于是第一个Ruby的随笔，先简单介绍一下ruby的语法规则吧。ruby的语法和python有点类似，但是不要求严格缩进（当然没什么特殊情况缩进是必须的），所以用end关键字来表示结束。</p>
<p>说实话还没有深究过ruby中的每一个变量类型，但是有一点是确定不变的：动态，强类型。所谓的强类型就是一个变量只能只一种类型，不能变成其他类型，而在实际使用中，你会发现一个变量是可以自由隐式转换的，比如</p>
<p>var=1</p>
<p>var=“string"</p>
<p>不会有任何问题，但是这并不表示ruby就是弱类型语言。和python类似，ruby中的变量其实就是内存的引用，当隐式改变一个变量的类型的时候，其实是新建了一块新的内存，并且将变量名指向新的地址，作为新值的引用，而原来的旧的内存内容当他的引用次数变成0的时候，就会被系统的垃圾回收机制适时地回收掉。（此处用python的内存原理类推了一下，并没有求证，如果有错误，希望大家多多提出）</p>
<p>ruby中用小写字母或者下划线开头的关键字作为变量名，以@开头作为实例变量名，用class关键字定义类，module关键字定义模块，def关键字定义方法，initialize方法来构造一个对象，return关键字返回值，用.调用方法等，没有任何很奇怪的语法，一切看起来都是那么自然。</p>
<h3>Ruby中的对象</h3>
<p>Ruby中到处都是对象，每一个对象都来自于某一个类，同时这个类可能继承于某一个父类。对象又可以称为类的实例，对象的属性，也就是类的实例变量，存放在对象中，而对象的方法，也就是类的实例方法，存放在类中。所以同一个类下的不同实例可以共享方法，但是实例变量确是不共享的。每一个类都继承与Object类，Object类中存放诸如class()（查看对象的类）等方法，而Object又是继承自BasicObject类（白板类，创建继承自白板类的对象可以消除之前可能存在的所有方法）。每一个对象的类都是Class，Class只是一个封装了new()等方法的Module......</p>
<p>说起来有点拗口，我大致画了一下示意图（实线表示class，虚线表示superclass）：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/675510/201504/052312076166669.png" /></p>
<h3>Ruby中的方法</h3>
<p>当你调用一个对象的方法时，系统会从该对象的类中查找是否有该方法，如果没有找到，则会依次到上一级父类中查找，直到找到该方法，如果没有找到，则会调用method_missing()方法，调用幽灵方法，或者报出调用错误的信息。可以调用ancestors方法，查看当前对象的祖先链（即上述查找过程的链结构，特别的，在Object之后，会查找Kernel模块，这是由于Object包含了Kernel模块，Kernel中包含print等方法），Ruby就是在祖先链上依次查找方法。</p>
<p>找到方法后，自然要执行了，然而按照以上所说，方法的查找需要经过一个祖先链，那么在调用这个方法的时候又是如何确定接受者的呢？在Ruby中，每一行代码都会在当前对象中执行，这个当前对象就是self，没有明确指定接受者的方法都在self上调用。</p>
<p>事实上，每个Ruby脚本执行时，都会创建一个main对象作为当前对象，此时，self就是main（main又可以称作顶级上下文，正如python中的顶格书写的代码，而不是c，c++中入口函数的概念）。</p>
<p>Ruby中的私有方法也和c++中有所不同。private关键字后面的方法只能被隐含接受者调用，（又由于调用方法时，如果接收者不是自己，则必须明确指定一个接收者，上述下划线文字）所以私有方法只能被自身调用。检查私有方法调用是否合法，只需检查是否指定了接收者（否）以及当前的self是谁。</p>
<p>扩展：在Ruby中，有种邪恶的方式可以得到任何规则的豁免来访问任何方法，包括private，即send方法。</p>
<h3>Ruby中的类操作</h3>
<p>在Ruby中，用class关键字定义一个类， 如果这个类不存在，那么会创建这个类，如果这个类存在了，则会对已有的类添加方法、属性等。这个操作对自带的类同样有效。如书上的一个例子，去除字符串中非字母、数字、空格的其他符号。想到的是一个用正则表达式来处理的方法：</p>
<p>def to_alphanumeric(s)</p>
<p>    s.gsub /^\w\s/, ''</p>
<p>end</p>
<p>在Ruby中，可以“打开”String类，并且在类中直接添加该方法：</p>
<p>class String</p>
<p>    def to_alphanumeric</p>
<p>        gsub /^\s\w/, ''</p>
<p>    end</p>
<p>end</p>
<p>于是在String中多了一个新的方法to_alphanumeric。</p>
<p>ps：这是我第一次知道可以有这样的定义方式，这让我感到耳目一新，就像开了一扇窗，外面全都是新的景色。</p>
<p>“打开”类添加方法的操作看起来很酷，但是仔细思考的话，其实是存在一定问题的：如果在String中，已经存在了to_alphanumeric方法，那么调用时是不能确定调用到哪个方法的。（截止到写这篇随笔的时候，我还不是很清楚在Ruby中实现C++的多态，或者是override等方式是什么样子的）</p>
<h3>Ruby中的常量和模块</h3>
<p>和python类似，用大写字母开头来表示一个常量。常量只在当前作用域下有效，类似于目录树的结构，其他作用域下的同名常量就像是不同目录下的同名文件，是不相关的。</p>
<p>从随笔开始的示意图中，Module是Class的superclass，其实Module（模块）就是一些实例方法的集合，和Class就是封装了若干功能的Module（如new()方法）。Module和Class非常类似，但是使用又截然不同，当需要被继承或者实例化的时候，应该选用Class（superclass()方法和new()方法），而当需要被其他地方包含（include、import）时，应该使用模块。</p>
<p>模块就像是目录，模块中的不同常量（方法或者属性的引用）就可以看成是文件，常量和模块组成一个类似文件树的结构，调用时用双冒号来表示路径（::）。用加上路径的显示方式可以唯一确定到常量的位置，这就是命名空间的概念。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495ldw08.html">允许webservice远程测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql3p26q.html">Android常见控件&mdash; &mdash; &mdash;AlertDialog</a>
		</li>
						<li><a href="https://www.batexi.com/a/495onzm8.html">RabbitMQ学习笔记4-使用fanout交换器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn70kz8.html">部分GDAL工具功能简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4znne09.html">从USB驱动器运行Windows 10</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp56e59.html">vue-miniQQ&mdash;&mdash;基于Vue2实现的仿手机QQ单页面应用（接入了聊天机器人，能够进行正常对话）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z57jj9.html">webview缓存及跳转时截取url地址、监听页面变化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpwxz79.html">论文阅读 &vert; A Curriculum Domain Adaptation Approach to the Semantic Segmentation of Urban Scenes</a>
		</li>
						<li><a href="https://www.batexi.com/a/9505xgz8.html">HTTP协议是无状态的</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljzpy19.html">Logstash安装介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllmd3eq.html">Day 15 模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyj25d9.html">绘制ROC曲线</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy6lxgq.html">activiti学习第二天</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2512k3q.html">TOP100summit：【分享实录-猫眼电影】业务纵横捭阖背后的技术拆分与融合</a>
		</li>
						<li><a href="https://www.batexi.com/a/960x6lv9.html">789A Anastasia and pebbles</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvrndx8.html">Installation failed with message&period;&period;&period;It is possible that this issue is resolved by uninstalling an existing version of the apk if it is present&comma; and then re-installing&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/902plmmq.html">吴裕雄 数据挖掘与分析案例实战（3）&mdash;&mdash;python数值计算工具：Numpy</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvdv7jyq.html">【转】VC 线程间通信的三种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy21orm9.html">盒子模型 以及CSS的box-sizing属性。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy22wgx9.html">Python3 Tkinter-Canvas</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/950n0nm8.html">Hibernate学习&lpar;五&rpar;Hibernate 多对多映射</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gexp1z8.html">运行期以索引获取tuple元素-C&plus;&plus;17</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mexjj2q.html">replace深入</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj24p5q.html">idea快速搭建springboot项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p4mov8.html">Linux高性能server编程&mdash;&mdash;信号及应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjldr38.html">体验CSDN-Markdown</a>
			</li>
						<li><a href="https://www.batexi.com/a/93y6n6z8.html">史上最强学生管理系统之IO版</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zoljp1q.html">Winform开发框架中工作流模块的表设计分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj25r1q.html">ASP&period;NET Core 异常重试组件 Polly</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m1egj8.html">有限等距性质RIP</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
